/* define the hash table functions */

#include <stdlib.h>

#include "symbol.h"
#include "symbol_hash.h"

/* List the names of the hash functions that you write. */

Hasher hashConstant;		/* a VERY simple hash function */
Hasher hashAdder;
Hasher hashShifter;
Hasher hashRadix;
Hasher hashPerfect;

/* An array of struct TestCase objects stores information about test cases. */

struct TestCase {
  char *name;			/* name of the test case */
  int tableSize;		/* size of the Hash table */
  Hasher *hash;			/* the Hasher function to use */
  Comparator *compare;		/* the Comparator function to use */
};

/* 
   Define the test cases that you want to run with the hash functions
   by adding rows between "Constant Hash" and NULL.
*/

struct TestCase test[] = {
  {"Constant Hash",100,hashConstant,symbolCompareByName},
/*    {"Character Add (Fig 5.3)",100,hashAdder,symbolCompareByName}, */
/*    {"Character Shift & Add (Fig 5.5)",100,hashShifter,symbolCompareByName}, */
/*    {"Character Radix 256",100,hashRadix,symbolCompareByName}, */
/*    {"Character Radix 256",101,hashRadix,symbolCompareByName}, */
/*    {"Character Radix 256",4096,hashRadix,symbolCompareByName}, */
/*    {"Character Radix 256",4099,hashRadix,symbolCompareByName}, */
/*    {"Perfect",101,hashPerfect,symbolCompareByName}, */
  {NULL,0,NULL,NULL}
};

/* These functions allow a caller to get information about the tests. */

char *getTestName(int idx) {
  return test[idx].name;
}

int getTestTableSize(int idx) {
  return test[idx].tableSize;
}

Hasher *getTestHasher(int idx) {
  return test[idx].hash;
}

Comparator *getTestComparator(int idx) {
  return test[idx].compare;
}

/*
  Your new hash functions go here.  They take an ElementType pointer
  to a Symbol and a table size as input, and return a HashIndex (an
  unsigned int) value.

  Remember that to cast a pointer of type ElementType to a Symbol
  pointer and then access the name value of the Symbol, you can say
  something like ((struct Symbol *)e)->name.  */

/*
  hashConstant always returns the same hash value (0), no matter what the
  Symbol is or the hash table size is.
*/

HashIndex hashConstant(ElementType e,int size) {
  HashIndex idx;
  idx = 0;
  return idx;
}

