#ifndef _list_h
#define _list_h

#include "element.h"

struct ListNode;

typedef struct ListNode *List;
typedef struct ListNode *Position;

List CreateList(void);		/* aka MakeEmpty */
List *CreateListArray(int n);
void ClearList(List L);		/* aka DeleteList */
void DestroyList(List L);
void DestroyListArray(List *LA,int n);

void PrintList(List L, ElementPrintLabel P);
int CountListEntries(List L);

Position InsertListEntry(List L, Position P, ElementType X);

int ListIsEmpty(List L);
Position GetFirstListEntry(List L);
Position AdvanceListEntry(Position P);
ElementType GetListEntryElement(Position P);
int ListEntryIsLast(List L,Position P);

Position FindListEntry(List L, ElementType X, Comparator C);
Position FindPreviousListEntry(List L,ElementType X,Comparator C);
void DeleteListEntry(List L, Position P);

#endif /* _list_h */
